/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.component.sushi


import org.apache.camel.Endpoint;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.impl.DefaultConsumer;

/**
 *
 * @author Narine Ghochikyan
 *
 */
class SushiConsumer extends DefaultConsumer {
	public SushiConsumer(Endpoint endpoint, Processor processor){
		super(endpoint, processor);
	}
	
	@Override
	protected void doStart() throws Exception {
		def configRoot = new ConfigSlurper().parse(new File(getConfigFilePath()).toURI().toURL());
		for (entry in configRoot.sushi) {
			Exchange exchange = getEndpoint().createExchange();
			exchange.getIn().setBody entry.getValue()

			processor.process exchange
		}
	}
		
	private String getConfigFilePath(){
		SushiEndpoint endpoint = (SushiEndpoint)getEndpoint();
		String path = System.getProperty("user.home") + File.separator;
		path += "." + endpoint.base + File.separator + endpoint.path + ".groovy"
	}
}
